/* $Id: microsoftcom.c,v 1.2 2003/09/17 07:15:24 short Exp $
 * W32 modules finder from microsoft.com Internet download
 * Copyright (C) 2003 Jan Kratochvil <project-captive@jankratochvil.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; exactly version 2 of June 1991 is required
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "config.h"

#include "microsoftcom.h"	/* self */
#include <glib/gmessages.h>
#include <libgnomevfs/gnome-vfs-uri.h>
#include <libgnomevfs/gnome-vfs-result.h>
#include <libgnomevfs/gnome-vfs-utils.h>
#include <string.h>

#include <captive/macros.h>


/* Config: */
/* Do we really need to use indirection by the following 'base' URL?
 * It appears to me as if some Microsoft Service Pack files URLs
 * have changed in the past.
 */
#define MICROSOFTCOM_URL "http://www.microsoft.com/WindowsXP/pro/downloads/servicepacks/sp1/checkedbuild.asp"


GList * /* of (GnomeVFSURI *) */ mod_uri_microsoftcom_list(void)
{
int base_size;
char *base_contents;
char *href,*href_end;
const char *href2;
GnomeVFSURI *uri;

	base_contents=NULL;
	if (GNOME_VFS_OK!=gnome_vfs_read_entire_file(MICROSOFTCOM_URL,&base_size,&base_contents)
			|| base_size<=0) {
		g_warning(_("Cannot load base URL: %s"),MICROSOFTCOM_URL);
		goto fail_free_base_contents;
		}
	base_contents[base_size-1]=0;	/* string terminator */
	if (!(href=strstr(base_contents,"http://download.microsoft.com/")) || !(href_end=strchr(href,'"'))) {
		g_warning(_("Destination file URL not found in base URL: %s"),MICROSOFTCOM_URL);
		goto fail_free_base_contents;
		}
	*href_end=0;
	if (strncmp(href,"http://",strlen("http://"))) {
		g_warning(_("Destination file URL not valid: %s"),href);
		goto fail_free_base_contents;
		}
	href2=captive_printf_alloca("httpcaptive://%s",href+strlen("http://"));
	if (!(uri=gnome_vfs_uri_new(href2))) {
		g_warning(_("Found destination file URL not parsable: %s"),href2);
		goto fail_free_base_contents;
		}
	g_free(base_contents);
	return g_list_append(NULL,uri);

fail_free_base_contents:
	g_free(base_contents);
	return NULL;
}
